#!/bin/bash
# SPDX-Version: 3.0
# SPDX-CreationInfo: 2025-06-17; WEIDNER, Marc S.; <msw@coresecret.dev>
# SPDX-ExternalRef: GIT https://git.coresecret.dev/msw/CISS.debian.installer.git
# SPDX-FileContributor: WEIDNER, Marc S.; Centurion Intelligence Consulting Agency
# SPDX-FileCopyrightText: 2024-2025; WEIDNER, Marc S.; <msw@coresecret.dev>
# SPDX-FileType: SOURCE
# SPDX-License-Identifier: EUPL-1.2 OR LicenseRef-CCLA-1.0
# SPDX-LicenseComment: This file is part of the CISS.debian.installer.secure framework.
# SPDX-PackageName: CISS.debian.installer
# SPDX-Security-Contact: security@coresecret.eu

guard_sourcing

#######################################
# Install microcode updates depending on architecture (amd64, arm64, intel64) and environment (Baremetal, VM).
# Every 'apt-get install' command is invoked by adding 'export INITRD=No'
# to suppress the 'update-initramfs'-Kernel-Hooks, according to the initramfs-tools manpage:
# https://manpages.debian.org/testing/initramfs-tools-core/initramfs-tools.7.en.html
# Globals:
#   TARGET
# Arguments:
#   None
# Returns:
#   0: on success
#######################################
installation_microcode() {
  ### Declare Arrays, HashMaps, and Variables.
  declare     var_microcode_pkgs="" var_whereiam="" var_cpu_vendor=""
  declare -r  var_logfile="/root/.ciss/cdi/log/4140_installation_microcode.log"

  touch "${TARGET}${var_logfile}" && chmod 0600 "${TARGET}${var_logfile}"

  # shellcheck disable=SC2312
  if [[ -x "$(command -v virt-what)" ]]; then
    var_whereiam=$(virt-what | head -n1)
  else
    var_whereiam=$(grep -iE 'kvm|vmware|qemu' /sys/class/dmi/id/product_name 2>/dev/null || echo "baremetal")
  fi

  # shellcheck disable=SC2312
  var_cpu_vendor=$(</proc/cpuinfo grep 'vendor_id' | head -n1 | cut -d: -f2 | xargs)

  case "${var_cpu_vendor}" in
    *AuthenticAMD*)   var_microcode_pkgs="amd64-microcode" ;;
    *GenuineIntel*)   var_microcode_pkgs="intel-microcode" ;;
    *)                do_log "info" "file_only" "4140() Unknown or unsupported CPU vendor: '${var_cpu_vendor}', skipping." ;;
  esac

  ###########################################################################################
  # Generally, it is best to let the hypervisor handle CPU microcode updates.               #
  ###########################################################################################
  if [[ "${var_whereiam}" != "kvm" && -n "${var_microcode_pkgs}" ]]; then

    if ! do_in_target_script "${TARGET}" "dpkg -s ${var_microcode_pkgs} >/dev/null 2>&1"; then

      do_in_target_script "${TARGET}" "
        export INITRD=No
        apt-get install -y --no-install-recommends --no-install-suggests ${var_microcode_pkgs} 2>&1 | tee -a ${var_logfile}
        echo ExitCode: \$? >> ${var_logfile}
      "

    else

      do_in_target_script "${TARGET}" "
        export INITRD=No
        apt-get install -y --no-install-recommends --no-install-suggests --only-upgrade ${var_microcode_pkgs} 2>&1 | tee -a ${var_logfile}
        echo ExitCode: \$? >> ${var_logfile}
      "

    fi

  else

    do_log "info" "file_only" "4140() Skipping microcode install [${var_whereiam}, ${var_microcode_pkgs:-none}]."

  fi

  guard_dir && return 0
}
# vim: number et ts=2 sw=2 sts=2 ai tw=128 ft=sh
